package filter

import (
	"net/http"

	"github.com/go-chi/chi"
	"go.mongodb.org/mongo-driver/bson"
)

type Filter bson.M

func ParseFromRequest(r *http.Request) (*Filter, error) {
	var filter Filter

	if err := bson.UnmarshalExtJSON([]byte(chi.URLParam(r, "filter")), true, &filter); err != nil {
		return nil, err
	}

	return &filter, nil
}

func (filter *Filter) Set(key string, value interface{}) {
	if filter == nil {
		filter = &Filter{}
	}

	(*filter)[key] = value
}

func (filter *Filter) Del(key string) {
	if filter == nil {
		return
	}

	if _, ok := (*filter)[key]; !ok {
		return
	}

	delete(*filter, key)
}
